# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(Test::Pod::No404s) when available

# We do not need a bleeding edge Module::Build::Tiny
%global old_mbt %(perl -MModule::Build::Tiny -e 'print (($Module::Build::Tiny::VERSION < 0.034) ? 1 : 0);' 2>/dev/null || echo 0)

# We need a recent version of Test::More
%global quite_old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION) < 0.99 ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-YAML-Tiny
Version:	1.58
Release:	1.%{__distinit}%{__distvers}
Summary:	Read/Write YAML files with as little code as possible
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/YAML-Tiny/
Source0:	http://search.cpan.org/CPAN/authors/id/E/ET/ETHER/YAML-Tiny-%{version}.tar.gz
Source1:	T-M-0.99.tar.gz
Patch0:		YAML-Tiny-1.57-spelling.patch
Patch1:		YAML-Tiny-1.57-old-M::B::T.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	perl(Module::Build::Tiny) >= 0.028
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
# Test Suite
BuildRequires:	perl(blib)
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.120900
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Spec) >= 0.80
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(IO::Dir)
BuildRequires:	perl(JSON) >= 2
BuildRequires:	perl(lib)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(utf8)
BuildRequires:	perl(vars)
BuildRequires:	perl(version)
BuildRequires:	perl(warnings)
BuildRequires:	perl(YAML)
BuildRequires:	perl(YAML::Syck)
BuildRequires:	perl(YAML::XS)
# Extra Tests
# perl-Test-Kwalitee -> perl-Module-CPANTS-Analyse -> perl-Test-CPAN-Meta-YAML -> perl-Test-YAML-Valid -> perl-YAML-Tiny
%if 0%{!?perl_bootstrap:1} && %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Test::CPAN::Changes)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Kwalitee)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling) >= 0.12, hunspell-en
BuildRequires:	perl(Test::Vars)
BuildRequires:	perl(Test::Version)
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)
Requires:	perl(Exporter)
Requires:	perl(Fcntl)
Requires:	perl(Scalar::Util)

%description
YAML::Tiny is a Perl class for reading and writing YAML-style files,
written with as little code as possible, reducing load time and
memory overhead.

%prep
%setup -q -n YAML-Tiny-%{version}

# We do not need a bleeding edge Module::Build::Tiny
%if %{old_mbt}
%patch1
%endif

# Add some stopwords for the POD spelling check
%patch0

# We need a recent version of Test::More
%if %{quite_old_test_more}
tar xfz %{SOURCE1}
find inc -type f >> MANIFEST
%endif

%build
# Use our local Test::More if necessary
[ -d inc/ ] && export PERL5LIB=$(pwd)/inc

perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0

%check
# Use our local Test::More if necessary
[ -d inc/ ] && export PERL5LIB=$(pwd)/inc

./Build test

# Extra tests (don't try to run them on old distros or when bootstrapping)
%if 0%{!?perl_bootstrap:1} && %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
LANG=en_US RELEASE_TESTING=1 prove -Ilib $(echo $(find xt/ -name '*.t'))
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes CONTRIBUTING LICENSE README README.md
%{perl_vendorlib}/YAML/
%{_mandir}/man3/YAML::Tiny.3pm*

%changelog
* Wed Feb  5 2014 Paul Howarth <paul@city-fan.org> 1.58-1
- Update to 1.58
  - 1.57 omitted a change entry for the following change:
  Incompatible change:
  - Previously, YAML::Tiny was sloppy about file encodings; it is now strict
  - The 'read' method and 'LoadFile' function expect UTF-8 encoded files
  - The 'write' method and 'DumpFile' function produce UTF-8 encoded files
  - The 'read_string' and 'write_string' methods and the 'Load' and 'Dump'
    functions expect or generate (decoded) character data

* Fri Jan 31 2014 Paul Howarth <paul@city-fan.org> 1.57-1
- Update to 1.57
  Incompatible change:
  - Previously, some errors would throw exceptions and some would return the
    error condition in $YAML::Tiny::errstr, but now all errors throw
    exceptions; use of $errstr and the errstr method are deprecated
  Fixed:
  - Fixed write method to encode YAML file with UTF-8
  - Improved SYNOPSIS and documentation of new
  Testing:
  - Tests have been cleaned up and reorganized
  - Test coverage has been significantly improved
- Instead of trying to patch around the need for a recent version of
  Test::More, bundle the version upstream wants and use that if necessary
- Add patch to support building with old Module::Build::Tiny versions
- Update spelling patch
- Package docs CONTRIBUTING and README.md
- Update dependencies as needed
- Don't try to run the extra tests unless we have Perl ≥ 5.10, as some
  of the testing modules aren't available and I don't want to have to patch
  the test suite to work around that

* Wed Sep 25 2013 Paul Howarth <paul@city-fan.org> 1.56-1
- Update to 1.56
  - read_string documentation error fixed (CPAN RT#74409)
  - Re-release with fixed compile test
- Go back to Module::Build::Tiny flow
- Drop redundant patch for building with old ExtUtils::MakeMaker versions
- Update other patches as needed
- Pod::Wordlist::hanekomu is not used, so we need to switch between aspell and
  hunspell based on where we're building

* Thu Sep 19 2013 Paul Howarth <paul@city-fan.org> 1.55-1
- Update to 1.55
  - Revert to ExtUtils::MakeMaker flow
- Update buildreqs as needed
- Update patches as needed
- Skip the spell check if we have Pod::Spell 1.07
  (https://github.com/xenoterracide/Pod-Spell/issues/9)

* Wed Sep  4 2013 Paul Howarth <paul@city-fan.org> 1.54-2
- Don't buildreq release test modules when bootstrapping

* Thu Aug 22 2013 Paul Howarth <paul@city-fan.org> 1.54-1
- Update to 1.54
  - Convert to Dist::Zilla
  - Updated format to conform to CPAN::Changes::Spec
- Upstream shipping README again
- Switch to Module::Build::Tiny flow
- Classify buildreqs by usage
- Add buildreqs for, and explicitly run the extra tests
- Add patches to support testing with old versions of test modules

* Wed Aug 21 2013 Paul Howarth <paul@city-fan.org> 1.53-1
- Update to 1.53
  - Updated repository metadata to reflect move to github
- This release by ETHER -> update source URL
- Upstream no longer shipping extra tests, so don't try to run them
- Upstream no longer shipping README
- Drop minperl patch since we're no longer running the minimum version test

* Thu Jul 18 2013 Paul Howarth <paul@city-fan.org> 1.51-7
- Perl 5.18 rebuild

* Tue Jun 11 2013 Paul Howarth <paul@city-fan.org> 1.51-5
- Build requires at least perl 5.6, not 5.4

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> 1.51-4
- Perl 5.16 post-bootstrap rebuild

* Mon Jul  2 2012 Paul Howarth <paul@city-fan.org> 1.51-3
- BR: perl(Carp),perl(Exporter), perl(File::Spec::Functions) and perl(YAML::XS)

* Sun Mar 11 2012 Paul Howarth <paul@city-fan.org> 1.51-1
- Update to 1.51
  - The fix described in 1.48 was incorrect; removed an additional "if $@" to
    fix it properly
  - Make the Scalar::Util version check resistant to bugs caused by
    development versions
- Drop patch for old Scalar::Util versions, no longer needed
- Don't need to remove empty directories from the buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Jun 30 2011 Paul Howarth <paul@city-fan.org> 1.50-2
- Rebuild for perl 5.14.1 in Rawhide
- Add support for perl_bootstrap macro
- No need for %%{?perl_default_filter} in this package
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> 1.50-1
- Update to 1.50
  - Major bug fix: all code that writes arbitrary data should upgrade
  - Simple scalars with no whitespace but ending in a colon like ABC: were not
    being quoted, which results in the parser confusing it with a mapping key
    and crashing
- Nobody else likes macros for commands

* Tue Feb  1 2011 Paul Howarth <paul@city-fan.org> 1.48-1
- Update to 1.48
  - Fix to the refaddr compatibility where Scalar::Util is installed but is
    older than 1.18
- BR: perl(Scalar::Util)
- Add patch to fix operation with Scalar::Util < 1.18 properly

* Mon Jan 31 2011 Paul Howarth <paul@city-fan.org> 1.47-1
- Update to 1.47
  - No functional changes
  - Only depend on the YAML implementations when we are release testing

* Thu Dec 16 2010 Paul Howarth <paul@city-fan.org> 1.46-1
- Update to 1.46
  - Added support for trailing line comments
  - Added checks for some characters that are illegal/reserved in plain scalars
  - Minor cleaning up of some out of date POD
  - Updated AUTOMATED_TESTING dependencies to new versions
  - Added experimental support for exception->errstr conversion
  - Updated test suite yaml_error to not expect exceptions

* Sun Aug  8 2010 Paul Howarth <paul@city-fan.org> 1.44-1
- Update to 1.44
  - No functional changes
  - Minor tweaks to Makefile.PL
  - Minor cleanup around the refaddr emulation code

* Mon Jul 19 2010 Paul Howarth <paul@city-fan.org> 1.43-1
- Update to 1.43
  - No functional changes
  - Don't import Carp 'croak' any more, saving a few K

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 1.42-1
- Update to 1.42
  - No functional changes
  - Clarified documentation regarding treatment of "bool" keywords
  - YAML::Perl comparison tests were behaving incorrectly
  - Author tests updated and moved into xt/
  - Updated the versions of the other YAML parsers for testing

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> 1.41-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> 1.41-2
- Fix dist tag for RHEL-6 Beta

* Tue Dec 22 2009 Paul Howarth <paul@city-fan.org> 1.41-1
- Update to 1.41 (performance fix for very long double-quoted strings)

* Tue Dec 22 2009 Paul Howarth <paul@city-fan.org> 1.40-3
- Import from Fedora

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> 1.40-2
- Rebuild against perl 5.10.1

* Sun Sep 27 2009 Chris Weyl <cweyl@alumni.drew.edu> 1.40-1
- Auto-update to 1.40 (by cpan-spec-update 0.01)

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 1.39-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat May 23 2009 Chris Weyl <cweyl@alumni.drew.edu> 1.39-1
- Auto-update to 1.39 (by cpan-spec-update 0.01)
- Added a new br on perl(File::Spec) (version 0.80)

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 1.36-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Jan 17 2009 Steven Pritchard <steve@kspei.com> 1.36-1
- Update to 1.36
- BR Test::More

* Fri May 16 2008 Steven Pritchard <steve@kspei.com> 1.32-1
- Update to 1.32

* Fri Feb  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.25-2
- Rebuild for new perl

* Mon Jan 28 2008 Steven Pritchard <steve@kspei.com> 1.25-1
- Update to 1.25

* Tue Dec 11 2007 Steven Pritchard <steve@kspei.com> 1.21-1
- Update to 1.21
- Update License tag
- BR Test::MinimumVersion

* Thu Aug 23 2007 Steven Pritchard <steve@kspei.com> 1.14-1
- Update to 1.14

* Fri Jul 13 2007 Steven Pritchard <steve@kspei.com> 1.13-1
- Update to 1.13

* Fri Jun 08 2007 Steven Pritchard <steve@kspei.com> 1.12-1
- Update to 1.12

* Mon May 28 2007 Steven Pritchard <steve@kspei.com> 1.09-1
- Update to 1.09

* Sat May 19 2007 Steven Pritchard <steve@kspei.com> 1.08-1
- Update to 1.08
- Update description

* Tue Mar 13 2007 Steven Pritchard <steve@kspei.com> 1.04-1
- Specfile autogenerated by cpanspec 1.70
- Drop redundant perl build dependency
- BR YAML, YAML::Syck, and Test::Pod for better test coverage
